<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama role" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Role
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="ownerRoles" ref="roleTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Nama Role"
                width="250">
                <template slot-scope="scope">
                    <span>{{ scope.row.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Deskripsi"
                width="375">
                <template slot-scope="scope">
                    <span>{{ scope.row.description }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Pemilik"
                width="150"
                v-if="me.role.slug == 'root'">
                <template slot-scope="{row}">
                    <span v-if="row.owner != null">{{ row.owner.profile.fullname }}</span>
                    <span v-else>Default</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Total Pengguna"
                width="200"
                v-if="me.role.slug == 'root'">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.total_user > 0" type="success" size="mini"> <i class="ion-ios-people"></i> {{ scope.row.total_user }} pengguna</el-tag>
                    <el-tag v-else type="info" size="mini"><i class="ion-ios-people"></i> {{ scope.row.total_user }} pengguna</el-tag>
                </template>
            </el-table-column>            
            <el-table-column
                label="Terkahir Diubah"
                width="150"
                v-if="me.role.slug == 'root'">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="250">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'permission', 'viewown']" type="text" @click="handlePermission(row)">Hak Akses</el-button>
                    <el-button v-permission="[row, 'role', 'editown']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'role', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>

        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="dialogLoading" :title="roleDialogTitle[roleDialogStatus]" :visible.sync="showRoleDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="roleForm" :model="roleForm" :rules="roleRules">
                <aside>
                    <el-alert type="info" description="Dengan Role anda dapat mengkelompokkan pengguna berdasarkan hak akses nya. Role dengan status read only tidak bisa dihapus atau diubah." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Nama Role" prop="name">
                    <el-input ref="name" name="name" v-model="roleForm.name" placeholder="Masukkan nama role" autocomplete="off" maxlength="255" show-word-limit></el-input>
                </el-form-item>
                <el-form-item label="Deskripsi" prop="description">
                    <el-input type="textarea" ref="description" name="description" v-model="roleForm.description" placeholder="Deskripsi role" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showRoleDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'row', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ roleDialogTitle[roleDialogStatus] }}
                </el-button>
            </span>
        </el-dialog>
        <el-dialog v-loading="dialogLoading" :title="permissionTitle" :visible.sync="showPermissionDialog" width="60%" :show-close="false">
            <aside>
                <el-alert type="info" description="Aktif / Non Aktifkan toggle untuk memberikan hak akses kepada role yang dipilih." :closable=false show-icon></el-alert>
            </aside>
            <el-table :data="ownerPermissions" ref="permissionTable" style="width: 100%" fit highlight-current-row>
                <el-table-column
                    fixed="left"
                    label="Modul"
                    width="175">
                    <template slot-scope="{row}">
                        <span style="color:#3E89FA;">{{ row.name }}</span>
                    </template>
                </el-table-column>
                <el-table-column
                    align="center"
                    label="Menu"
                    width="100">
                    <template slot-scope="{row}">
                        <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['menu']" @change="handlePermissionChange({'module': row.slug, 'permission': 'menu', 'value': $event})"></el-switch>
                    </template>
                </el-table-column>
                <el-table-column
                    align="center"
                    label="View All"
                    width="100">
                    <template slot-scope="{row}">
                        <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['viewall']" @change="handlePermissionChange({'module': row.slug, 'permission': 'viewall', 'value': $event})"></el-switch>
                    </template>
                </el-table-column>
                <el-table-column
                    align="center"
                    label="Create"
                    width="100">
                    <template slot-scope="{row}">
                        <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['create']" @change="handlePermissionChange({'module': row.slug, 'permission': 'create', 'value': $event})"></el-switch>
                    </template>
                </el-table-column>                
                <el-table-column
                    align="center"
                    label="View Own"
                    width="100">
                    <template slot-scope="{row}">
                        <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['viewown']" @change="handlePermissionChange({'module': row.slug, 'permission': 'viewown', 'value': $event})"></el-switch>
                    </template>
                </el-table-column>
                <el-table-column
                    align="center"
                    label="View Other"
                    width="100">
                    <template slot-scope="{row}">
                        <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['viewother']" @change="handlePermissionChange({'module': row.slug, 'permission': 'viewother', 'value': $event})"></el-switch>
                    </template>
                </el-table-column>
                <el-table-column
                    align="center"
                    label="Edit Own"
                    width="100">
                    <template slot-scope="{row}">
                        <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['editown']" @change="handlePermissionChange({'module': row.slug, 'permission': 'editown', 'value': $event})"></el-switch>
                    </template>
                </el-table-column>
                <el-table-column
                    align="center"
                    label="Edit Other"
                    width="100">
                    <template slot-scope="{row}">
                        <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['editother']" @change="handlePermissionChange({'module': row.slug, 'permission': 'editother', 'value': $event})"></el-switch>
                    </template>
                </el-table-column>
                <el-table-column
                    align="center"
                    label="Delete Own"
                    width="100">
                    <template slot-scope="{row}">
                        <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['deleteown']" @change="handlePermissionChange({'module': row.slug, 'permission': 'deleteown', 'value': $event})"></el-switch>
                    </template>
                </el-table-column>
                <el-table-column
                    align="center"
                    label="Delete Other"
                    width="120">
                    <template slot-scope="{row}">
                        <el-switch :active-value="1" :inactive-value="0" :value="defaultPermissions[row.slug]['deleteother']" @change="handlePermissionChange({'module': row.slug, 'permission': 'deleteother', 'value': $event})"></el-switch>
                    </template>
                </el-table-column>
            </el-table>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showPermissionDialog = false" size="medium">Tutup</el-button>
                <el-button v-permission="[null, 'role', 'editown']" @click="handleSubmitPermission" size="mini" type="success"><i class="ion-ios-checkmark-circle"></i> Ubah Hak Akses</el-button>
            </span>
        </el-dialog>
    </div>
</template>

<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import checkPermission from '@/utils/permission';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'Role',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data() {

        return {
            defaultRole: ['orphan', 'root', 'owner', 'leader', 'vice', 'security', 'finance', 'secretary', 'resident', 'public'],
            tableLoading: false,
            dialogLoading: false,
            filter: {
                keyword: ''
            },
            showRoleDialog: false,
            showPermissionDialog: false,
            roleDialogStatus: '',
            roleDialogTitle: {
                edit: 'Ubah Role',
                create: 'Tambah Role'
            },
            roleForm: {
                id: null,
                name: '',
                description: '',
                archived: false
            },
            roleRules: {
                name: [{ 
                    required: true, message: 'Nama role wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama role maksimal 255 karakter', trigger: 'blur',
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                description: [{ max: 255, message:'Panjang deskripsi maksimal 255 karakter', trigger: 'blur'}]
            },
            permissionTitle: '',
            currentRole: null
        }
    },
    computed: {
        tableHeight,
        checkPermission,
        ...mapGetters('user', ['me']),
        ...mapGetters('role', [
            'permissions',
            'roles',
            'pagination'
        ]),
        defaultPermissions: {
            get(){
                return this.$store.getters['role/defaultPermissions'];
            },
            set(){
                return;
            }
        },
        ownerRoles: function(){
            if(this.me.role.slug == 'root'){
                return this.roles;
            }else{
                return this.roles.filter((x) => ['orphan', 'root'].indexOf(x.slug) < 0);
            }
        },
        ownerPermissions: function(){
            if(this.me.role.slug == 'root'){
                return this.permissions;
            }else{
                return this.permissions.filter((x) => x.shared == true);
            }
        }
    },
    created(){
        this.getPermissions();
        this.getRoles();
    },
    methods: {
        playSound,
        dateFormat,       
        getPermissions() {
            this.tableLoading = true;
            this.$store.dispatch('role/getAllPermissions', {
                perpage: 100
            }).then(() => {});
        },
        getRoles() {
            this.tableLoading = true;
            this.$store.dispatch('role/getAllRoles', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){
            this.tableLoading = true;
            this.$store.dispatch('role/getAllRoles', {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.roleDialogStatus = 'create';
            this.showRoleDialog = true;          
            this.$nextTick(() => {
                this.$refs['roleForm'].clearValidate();
            });
        },
        handleEdit(role){
            this.roleDialogStatus = 'edit';
            this.showRoleDialog = true;   
            this.roleForm.id = role.id;
            this.roleForm.name = role.name;
            this.roleForm.description = role.description;  
            this.roleForm.archived = role.archived;
            this.$nextTick(() => {
                this.$refs['roleForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.roleForm.validate(valid => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.roleDialogStatus == 'create'){
                        action = 'role/addRole';
                        payload = {
                            name: this.roleForm.name,
                            description: this.roleForm.description
                        };
                    }else if(this.roleDialogStatus == 'edit'){
                        action = 'role/editRole';
                        payload = {
                            id: this.roleForm.id,
                            name: this.roleForm.name,
                            description: this.roleForm.description,
                            archived: this.roleForm.archived
                        };
                    }
                    
                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showRoleDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });
                }else{
                    return false;
                }
            });
        },
        handleDelete(role){

            this.$confirm('Anda mencoba untuk menghapus data role, data tidak bisa dikembalikan setelah dihapus. Semua role akan dialihkan menjadi role "orphan", anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('role/deleteRole', {
                    id: role.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showRoleDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        handlePermission(role){
            this.currentRole = role;
            this.permissionTitle = 'Hak Akses Role: ' + role.name;
            this.showPermissionDialog = true;
            this.defaultPermissions = Object.assign(this.defaultPermissions, role.permissions);
        },
        handleSubmitPermission(){
            this.dialogLoading = true;
            this.$store.dispatch('role/updateRolePermission', {
                id: this.currentRole.id,
                permissions: this.defaultPermissions
            }).then((response) => {
                this.dialogLoading = false;
                if('errors' in response){
                    let error = parseError(response.errors);
                    this.$message.error({
                        message: error.messages
                    });
                }else{
                    this.showRoleDialog = false;
                    this.$message.success({
                        message: response.message
                    });
                }
                this.playSound();
                this.showPermissionDialog = false;
            });
        },
        handlePermissionChange(payload){
            this.$store.dispatch('role/updateDefaultPermission', payload);
        },
        resetForm() {
            this.roleForm = {
                id: null,
                name: '',
                description: ''
            }
        }
    }
}
</script>
